//librerie per il modulo radio
#include <SPI.h>      
#include <Mirf.h>    
#include <nRF24L01.h> 
#include <MirfHardwareSpiDriver.h> 

//libreria per il sensore giroscopico
#include<Wire.h>

//variabili per il giroscopio
const int MPU_addr=0x68;   // MPU address
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;  // 16 bit data array
int minVal=265; 
int maxVal=402;
double x; double y; double z;
int clacson = 7;

 
void setup() {
  Serial.begin(9600);
  //Serial.println("Library initialization; EC/CSN pin and channel definition and module transmission and reception address definition");
  delay(2000);
  
  //setup del modulo radio
  Mirf.cePin = 9; 
  Mirf.csnPin = 10; 
  Mirf.spi = &MirfHardwareSpi; 
  Mirf.init();  
  Mirf.channel = 1; 
  Mirf.payload = sizeof(float); 
  Mirf.config(); 
  Mirf.setTADDR((byte *) "radio"); 
  Mirf.setRADDR((byte *) "radi1");

  //setup del sensore giroscopico
  Wire.begin();
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x6B); 
  Wire.write(0); 
  Wire.endTransmission(true); 
}
 
void loop() {
  //acquisizione degli angoli di inclunazione del giroscopio
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x3B); 
  Wire.endTransmission(false); 
  Wire.requestFrom(MPU_addr,14,true); 
 
  AcX=Wire.read()<<8|Wire.read(); 
  AcY=Wire.read()<<8|Wire.read(); 
  AcZ=Wire.read()<<8|Wire.read(); 
  
  int xAng = map(AcX,minVal,maxVal,-90,90);
  int yAng = map(AcY,minVal,maxVal,-90,90); 
  int zAng = map(AcZ,minVal,maxVal,-90,90);

  x= RAD_TO_DEG * (atan2(-yAng, -zAng)+PI); 
  y= RAD_TO_DEG * (atan2(-xAng, -zAng)+PI); 
  z= RAD_TO_DEG * (atan2(-yAng, -xAng)+PI);

  /*Serial.print(x); 
  Serial.print(" "); 
  
  Serial.print(y); 
  Serial.print(" "); 
  /*    
  Serial.print(z); 
  Serial.print(" ");
  */
  Serial.print("\n"); 

  //invio dei dati alla macchinina
  float value = x; 

  if(y>30&&y<140){
    value+=1000;
  }
  else if(y<330&&y>220){
    value+=2000;
  }

  if(digitalRead(clacson)==1){
    value+=10000;
  }
  
  Serial.println(value);
  Mirf.send((byte *) &value); 
  while(Mirf.isSending()); 
}  
